﻿Imports System.Collections.ObjectModel
Imports System.ComponentModel
Imports System.Runtime.CompilerServices
Imports _2_1_4_5_DataTemplates.Classes

Public Class AllTransports
    Implements INotifyPropertyChanged


    Public Sub New()
        AllTransports = New ObservableCollection(Of TransportBase)
        With AllTransports
            .Add(New Car() With {.Brand = "Volkswagen", .Cylinders = 4, .Model = "Arteon", .TopSpeed = 260, .Weight = 1616, .Equipment = New List(Of CarEquipment) From {
                 New CarEquipment() With {.Caption = "Automatische Distanzregelung ACC", .Description = "bis 210 km/h inkl. Umfeldbeobachtungssystem 'Front Assist' und adaptiver Geschwindigkeitsregelanlage"},
                                     New CarEquipment() With {.Caption = "Active Info Display", .Description = "Kombiinstrument in Form von einem TFT Display"},
                    New CarEquipment() With {.Caption = "ParkPilot", .Description = "akustische Warnsignale bei Hindernissen im Front- und Heckbereich"}}})
            .Add(New Helicopter() With {.Brand = "Boing", .RotorDiameter = 14.63, .Model = "AH-64 Apache", .TopSpeed = 293, .Weight = 6552, .PeakHeight = 6400})
            .Add(New Airplane() With {.Brand = "Boeing", .MaxAltitude = 10700, .Model = "747-200F", .TurbinesCount = 4, .TopSpeed = 0.84, .Weight = 396.9})
            .Add(New Ship() With {.Brand = "RMS Titanic", .Draft = 6, .LoadedDraft = 10.54, .Model = "", .TopSpeed = 24, .Weight = 39380})
        End With


        SelectedTransport = AllTransports.First
    End Sub

    Private _allTransports As ObservableCollection(Of TransportBase)
    Public Property AllTransports() As ObservableCollection(Of TransportBase)
        Get
            Return _allTransports
        End Get
        Set(ByVal value As ObservableCollection(Of TransportBase))
            _allTransports = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _selectedTransport As TransportBase

    Public Property SelectedTransport() As TransportBase
        Get
            Return _selectedTransport
        End Get
        Set(ByVal value As TransportBase)
            _selectedTransport = value
            RaisePropertyChanged()
        End Set
    End Property





    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub


    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
End Class
